Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3610)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3611)
@@ -993,88 +896,75 @@
 
 
-    ! --- CHECK UNITS
-    !>-----------------------------------------------------
-    !> Conversion of the units to the ones employed in PALM. 
-    !> Possible temporal units of input emissions data are: year, hour and second; 
-    !> the mass could be expressed in: tons, kilograms or grams. 
-    !> IN the PARAMETERIZED mode no conversion is possible: in this case INPUTS have to have fixed units.
-    !>-----------------------------------------------------
-
-        IF (TRIM(mode_emis)=="DEFAULT" .OR. TRIM(mode_emis)=="PRE-PROCESSED" ) THEN
-
-          SELECT CASE(TRIM(emt_att%units))
-          !> kilograms
-             CASE ( 'kg/m2/s','KG/M2/S') 
-                CALL location_message( 'Units of the emissions are consistent with'  //          &
-                                       ' the ones employed in the PALM-4U model ', .FALSE. )
+       !
+       !-- Conversion of units to the ones employed in PALM 
+       !-- In PARAMETERIZED mode no conversion is performed: in this case input units are fixed
+
+        IF ( TRIM( mode_emis ) == "DEFAULT" .OR. TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
+
+          SELECT CASE ( TRIM( emt_att%units ) )
+             !
+             !-- kilograms
+             CASE ( 'kg/m2/s', 'KG/M2/S' ) 
+                
                 con_factor=1
 
-             CASE ('kg/m2/hour','KG/M2/HOUR')
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
+             CASE ('kg/m2/hour', 'KG/M2/HOUR' )
 
                 con_factor=hour_to_s
 
-             CASE ( 'kg/m2/day','KG/M2/DAY' ) 
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'kg/m2/day', 'KG/M2/DAY' ) 
+                
                 con_factor=day_to_s
 
-             CASE ( 'kg/m2/year','KG/M2/YEAR' )
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'kg/m2/year', 'KG/M2/YEAR' )
+              
                 con_factor=year_to_s
 
-          !> Tons
-             CASE ( 'ton/m2/s','TON/M2/S' ) 
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             !
+             !-- Tons
+             CASE ( 'ton/m2/s', 'TON/M2/S' ) 
+               
                 con_factor=tons_to_kg
 
-             CASE ( 'ton/m2/hour','TON/M2/HOUR' ) 
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'ton/m2/hour', 'TON/M2/HOUR' ) 
+               
                 con_factor=tons_to_kg*hour_to_s
 
-             CASE ( 'ton/m2/year','TON/M2/YEAR' ) 
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'ton/m2/year', 'TON/M2/YEAR' ) 
+               
                 con_factor=tons_to_kg*year_to_s
 
-          !> Grams
-             CASE ( 'g/m2/s','G/M2/S' )
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             !
+             !-- Grams
+             CASE ( 'g/m2/s', 'G/M2/S' )
+          
                 con_factor=g_to_kg
 
-             CASE ( 'g/m2/hour','G/M2/HOUR' ) 
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
+             CASE ( 'g/m2/hour', 'G/M2/HOUR' ) 
 
                 con_factor=g_to_kg*hour_to_s
 
-             CASE ( 'g/m2/year','G/M2/YEAR' )
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'g/m2/year', 'G/M2/YEAR' )
+ 
                 con_factor=g_to_kg*year_to_s
 
-          !> Micro Grams
-             CASE ( 'micrograms/m2/s','MICROGRAMS/M2/S' )
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             !
+             !-- Micrograms
+             CASE ( 'micrograms/m2/s', 'MICROGRAMS/M2/S' )
+ 
                 con_factor=miug_to_kg
 
-             CASE ( 'micrograms/m2/hour','MICROGRAMS/M2/HOUR' ) 
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'micrograms/m2/hour', 'MICROGRAMS/M2/HOUR' ) 
+ 
                 con_factor=miug_to_kg*hour_to_s
 
-             CASE ( 'micrograms/m2/year','MICROGRAMS/M2/YEAR' )
-                CALL location_message( 'Units of emission inputs need conversion', .FALSE. )
-
+             CASE ( 'micrograms/m2/year', 'MICROGRAMS/M2/YEAR' )
+  
                 con_factor=miug_to_kg*year_to_s
 
              CASE DEFAULT  
-                message_string = 'The Units of the provided input chemistry emission species' // &
+                message_string = 'The Units of the provided emission input' // &
                                  ' are not the ones required by PALM-4U: please check '      // &
-                                 ' chemistry emission module documentation.'                                 
+                                 ' emission module documentation.'                                 
                 CALL message( 'chem_emissions_setup', 'CM0446', 2, 2, 0, 6, 0 )
 
@@ -1082,95 +972,88 @@
 
          
-       !> PRE-PROCESSED and parameterized mode
-       ELSE 
- 
-          message_string = 'No Units conversion required for units of chemistry emissions' // &
-                           ' of the PARAMETERIZED mode: units have to be provided in'     //  & 
-                           ' micromole/m**2/day for GASES and'                            //  &
-                           ' kg/m**2/day for PMs'                      
-          CALL message( 'chem_emissions_setup', 'CM0447', 0, 0, 0, 6, 0 ) 
-
        ENDIF
 
-    !> Conversion factors (if the units are kg/m**2/s) we have to convert them to ppm/s
-     DO i=nxl,nxr
-          DO j=nys,nyn
-          !> Derive Temperature from Potential Temperature
+       !
+       !-- Conversion factor to convert  kg/m**2/s to ppm/s
+       DO i = nxl, nxr
+          DO j = nys, nyn
+             !
+             !-- Derive Temperature from Potential Temperature
              tmp_temp(nzb:nzt+1,j,i) = pt(nzb:nzt+1,j,i) * ( hyp(nzb:nzt+1) * pref_i )**r_cp
-
-             !> We need to pass to cssws<- (ppm/s) * dz. 
-             !  Input is Nmole/(m^2*s)
-             !  To go to ppm*dz basically we need to multiply the input by (m**2/N)*dz
-             !  (m**2/N)*dz == V/N 
-             !  V/N=RT/P 
-
-             !>    m**3/Nmole              (J/mol)*K^-1           K                      Pa         
+             
+             
+             !>  We need to pass to cssws <- (ppm/s) * dz 
+             !>  Input is Nmole/(m^2*s)
+             !>  To go to ppm*dz multiply the input by (m**2/N)*dz
+             !>  (m**2/N)*dz == V/N 
+             !>  V/N = RT/P 
+             !>  m**3/Nmole               (J/mol)*K^-1           K                      Pa         
              conv_to_ratio(nzb:nzt+1,j,i) = ( (Rgas * tmp_temp(nzb:nzt+1,j,i)) / ((hyp(nzb:nzt+1))) )  
           ENDDO
        ENDDO
 
-    !>------------------------------------------------
-    !> Start The Processing of the input data
-
-        emis_distribution(:,nys:nyn,nxl:nxr,:) = 0.0_wp
-
-    !>-----------------------------------------------
-    !> Distinguish between DEFAULT, PRE-PROCESSED and PARAMETERIZED mode when calculating time_factors: only done for DEFAULT mode. For the PARAMETERIZED mode there is a time factor but it is fixed in the model 
+
+       !
+       !-- Initialize
+       emis_distribution(:,nys:nyn,nxl:nxr,:) = 0.0_wp
+
   
-    !> PRE-PROCESSED MODE 
-       IF (TRIM(mode_emis)=="PRE-PROCESSED") THEN
-
-          !> Update time indices
-          CALL time_preprocessed_indices(index_hh)
-
-          CALL location_message( 'PRE-PROCESSED MODE: No time-factor specification required', .FALSE. )
-
-       ELSEIF (TRIM(mode_emis)=="DEFAULT") THEN
-
-          CALL location_message( 'DEFAULT MODE: time-factor specification required', .FALSE. )
- 
-       !> Allocate array where to store temporary emission values      
-          IF(.NOT. ALLOCATED(emis)) ALLOCATE(emis(nys:nyn,nxl:nxr))
-
-       !> Allocate time factor per emitted component category
-          ALLOCATE(time_factor(emt_att%ncat))  
-
-       !> Read-in HOURLY emission time factor
-          IF (TRIM(time_fac_type)=="HOUR") THEN
-
-          !> Update time indices
-             CALL time_default_indices(month_of_year,day_of_month,hour_of_day,index_hh)
-
-          !> Check if the index is less or equal to the temporal dimension of HOURLY emission files              
-             IF (index_hh .LE. SIZE(emt_att%hourly_emis_time_factor(1,:))) THEN
-
-             !> Read-in the correspondant time factor              
-                time_factor(:)= emt_att%hourly_emis_time_factor(:,index_hh)      
+       !
+       !-- PRE-PROCESSED MODE 
+       IF ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
+
+          !
+          !-- Update time indices
+          CALL time_preprocessed_indices( index_hh )
+
+       ELSEIF ( TRIM( mode_emis ) == "DEFAULT" )  THEN
+
+          !
+          !-- Allocate array where to store temporary emission values      
+          IF ( .NOT. ALLOCATED(emis) ) ALLOCATE( emis(nys:nyn,nxl:nxr) )
+          !
+          !-- Allocate time factor per category
+          ALLOCATE( time_factor(emt_att%ncat) )  
+          !
+          !-- Read-in hourly emission time factor
+          IF ( TRIM( time_fac_type ) == "HOUR" )  THEN
+
+             !
+             !-- Update time indices
+             CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
+             !
+             !-- Check if the index is less or equal to the temporal dimension of HOURLY emission files              
+             IF ( index_hh <= SIZE( emt_att%hourly_emis_time_factor(1,:) ) )  THEN
+                !
+                !-- Read-in the correspondant time factor              
+                time_factor(:) = emt_att%hourly_emis_time_factor(:,index_hh)      
 
              ELSE
 
-                message_string = 'The "HOUR" time-factors (DEFAULT mode) of the chemistry emission species'           // &
+                message_string = 'The "HOUR" time-factors in the DEFAULT mode '           // &
                               ' are not provided for each hour of the total simulation time'      
                 CALL message( 'chem_emissions_setup', 'CM0448', 2, 2, 0, 6, 0 ) 
 
              ENDIF
-
-       !> Read-in MDH emissions time factors
-          ELSEIF (TRIM(time_fac_type)=="MDH") THEN
-
-          !> Update time indices      
-             CALL time_default_indices(daytype_mdh,month_of_year,day_of_month,hour_of_day,index_mm,index_dd,index_hh)
-
-
-          !> Check if the index is less or equal to the temporal dimension of MDH emission files              
-             IF ((index_hh+index_dd+index_mm) .LE. SIZE(emt_att%mdh_emis_time_factor(1,:))) THEN
-
-             !> Read-in the correspondant time factor              
-                time_factor(:)=emt_att%mdh_emis_time_factor(:,index_mm)*emt_att%mdh_emis_time_factor(:,index_dd)*   &
+          !
+          !-- Read-in MDH emissions time factors
+          ELSEIF ( TRIM( time_fac_type ) == "MDH" )  THEN
+
+             !
+             !-- Update time indices      
+             CALL time_default_indices( daytype_mdh, month_of_year, day_of_month,     &
+                  hour_of_day, index_mm, index_dd,index_hh )
+
+             !
+             !-- Check if the index is less or equal to the temporal dimension of MDH emission files              
+             IF ( ( index_hh + index_dd + index_mm) <= SIZE( emt_att%mdh_emis_time_factor(1,:) ) )  THEN
+                !
+                !-- Read-in the correspondant time factor              
+                time_factor(:) = emt_att%mdh_emis_time_factor(:,index_mm) * emt_att%mdh_emis_time_factor(:,index_dd) *   &
                                                                          emt_att%mdh_emis_time_factor(:,index_hh)
      
              ELSE
 
-                message_string = 'The "MDH" time-factors (DEFAULT mode) of the chemistry emission species'           // &
+                message_string = 'The "MDH" time-factors in the DEFAULT mode '           //  &
                               ' are not provided for each hour/day/month  of the total simulation time'      
                 CALL message( 'chem_emissions_setup', 'CM0449', 2, 2, 0, 6, 0 )
@@ -1179,27 +1062,26 @@
 
           ELSE
-          !> condition when someone used the DEFAULT mode but forgets to indicate the time-factor in the namelist
-             
-             message_string = 'The time-factor (DEFAULT mode) of the chemistry emission species'           // &
-                              ' is not provided in the NAMELIST'      
+                 
+             message_string = 'In the DEFAULT mode the time factor'           //  &
+                              ' has to be defined in the NAMELIST'      
              CALL message( 'chem_emissions_setup', 'CM0450', 2, 2, 0, 6, 0 )
          
           ENDIF
 
-       !> PARAMETERIZED MODE
-       ELSEIF (TRIM(mode_emis)=="PARAMETERIZED") THEN
-          CALL location_message( 'PARAMETERIZED MODE: time-factor specification is fixed: '                         // &
-                                 ' 24 values for every day of the year ', .FALSE. )
+       !
+       !-- PARAMETERIZED MODE
+       ELSEIF ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
         
-          !Assign Constant Values of time factors, diurnal time profile for traffic sector:
-          par_emis_time_factor( : ) = &
-            (/ 0.009, 0.004, 0.004, 0.009, 0.029, 0.039, 0.056, 0.053, 0.051, 0.051, 0.052, 0.055, &
+          !
+          !-- assign constant values of time factors, diurnal time profile for traffic sector
+          par_emis_time_factor( : ) =  &
+            (/ 0.009, 0.004, 0.004, 0.009, 0.029, 0.039, 0.056, 0.053, 0.051, 0.051, 0.052, 0.055,  &
                0.059, 0.061, 0.064, 0.067, 0.069, 0.069, 0.049, 0.039, 0.039, 0.029, 0.024, 0.019 /)
           
-          !> in this case allocate time factor each hour in a day
-          IF (.NOT. ALLOCATED(time_factor)) ALLOCATE(time_factor(1))
-
-          !>Pass the values of time factors in the parameterized mode to the time_factor variable. in this case index_hh==hour_of_day
-          index_hh=hour_of_day
+          IF ( .NOT. ALLOCATED( time_factor ) ) ALLOCATE( time_factor(1) )
+
+          !
+          !-- Get time-factor for specific hour
+          index_hh = hour_of_day
 
           time_factor(1) = par_emis_time_factor(index_hh)
@@ -1207,122 +1089,137 @@
        ENDIF
 
-!--------------------------------
-!--  EMISSION DISTRIBUTION Calculation
-
-       !> PARAMETERIZED CASE
-       IF ( mode_emis == "PARAMETERIZED" ) THEN
-
-          DO ispec=1,nspec_out
-
-             !> Values are still micromoles/(m**2*s). Units in this case are always micromoles/m**2*day (or kilograms/m**2*day for PMs)
-             emis_distribution(1,nys:nyn,nxl:nxr,ispec)=surface_csflux(match_spec_input(ispec))*time_factor(1)*hour_to_s
+       
+       !
+       !--  Emission distribution calculation
+
+       !
+       !-- PARAMETERIZED case
+       IF ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
+
+          DO ispec = 1, nspec_out
+
+             !
+             !-- Units are micromoles/m**2*day (or kilograms/m**2*day for PMs)
+             emis_distribution(1,nys:nyn,nxl:nxr,ispec) = surface_csflux(match_spec_input(ispec)) *  &
+                                                           time_factor(1) * hour_to_s
 
           ENDDO 
 
-       !> PRE-PROCESSED CASE
-       ELSEIF (TRIM(mode_emis)=="PRE-PROCESSED") THEN
-
-          !> Start Cycle over Species
-          DO ispec=1,nspec_out !> nspec_out represents the number of species in common between 
-                               !  the emission input data and the chemistry mechanism used
+       !
+       !-- PRE-PROCESSED case
+       ELSEIF ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
+
+          !
+          !-- Cycle over species:
+          !-- nspec_out represents the number of species in common between the emission input data
+          !-- and the chemistry mechanism used
+          DO ispec=1,nspec_out  
     
-             emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emt(match_spec_input(ispec))%                               &
-                                                                   preproc_emission_data(index_hh,1,nys+1:nyn+1,nxl+1:nxr+1)* &
-                                                                      con_factor
+             emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emt(match_spec_input(ispec))%                                 &
+                                                            preproc_emission_data(index_hh,1,nys+1:nyn+1,nxl+1:nxr+1) * &
+                                                                con_factor
           
           ENDDO
-
-      !TBD: At the moment the default mode considers a single vertical level (the surface). So we need to change it accordingly or eventually include the variable vertical_profile to be used in the default mode i we want to consider additional levels.
-
-       ELSE IF (TRIM(mode_emis)=="DEFAULT") THEN
-
-       !> Allocate array for the emission value corresponding to a specific category and time factor
-          ALLOCATE(delta_emis(nys:nyn,nxl:nxr))  
-
-
-       !> Start Cycle over categories
+          
+       !
+       !-- DEFAULT case
+       ELSEIF ( TRIM( mode_emis ) == "DEFAULT" )  THEN
+
+          !
+          !-- Allocate array for the emission value corresponding to a specific category and time factor
+          ALLOCATE( delta_emis(nys:nyn,nxl:nxr) )  
+
+          !
+          !-- Cycle over categories
           DO icat = 1, emt_att%ncat
  
-          !> Start Cycle over Species
-             DO ispec=1,nspec_out !> nspec_out represents the number of species in common between 
-                                  !  the emission input data and the chemistry mechanism used
+             !
+             !-- Cycle over Species
+             !-- nspec_out represents the number of species in common between the emission input data
+             !-- and the chemistry mechanism used
+             DO ispec = 1, nspec_out
 
                 emis(nys:nyn,nxl:nxr) = emt(match_spec_input(ispec))%default_emission_data(icat,nys+1:nyn+1,nxl+1:nxr+1)
 
-!TBD: The consideration of dt_emis of the input data is still missing. Basically the emissions could be provided every 10, 30 minutes and not always at one hour. This should be eventually solved in the date_and_time mode routine.
-
-             !> the time factors are 24 for each day. When multiplied by a daily value, they allow to have an hourly value. Then to convert it to seconds, we still have to divide this value by 3600. 
-             !  So given any units, we convert them to seconds and finally multiply them by 24 ((value/sec)*(24*3600)=value/day ---- (value/day)*time_factor=value/hour ---(value/hour)/(3600)=value/sec )
-             !                                                                                 ((value/sec)*(24*3600)*time_factor)/3600=24*(value/sec)*time_factor                          
-
-             !> NOX Compositions
-                IF (TRIM(spc_names(match_spec_model(ispec)))=="NO") THEN
-                !>             Kg/m2*s                   kg/m2*s
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                 emt_att%nox_comp(icat,1)*con_factor*hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
-
-                ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="NO2") THEN
-
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                 emt_att%nox_comp(icat,2)*con_factor*hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
- 
-             !> SOX Compositions
-
-                ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="SO2") THEN
-                   !>             Kg/m2*s                   kg/m2*s
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                 emt_att%sox_comp(icat,1)*con_factor*hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
-
-                ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="SO4") THEN
-                   !>             Kg/m2*s                   kg/m2*s
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                 emt_att%sox_comp(icat,2)*con_factor*hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
- 
-
-             !> PMs should be in kg/m**2/s, so conversion factor is here still required
-             !> PM1 Compositions
-                ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1") THEN
-
-                !> Cycle over the different pm components for PM1 type
-                   DO i_pm_comp= 1,SIZE(emt_att%pm_comp(1,:,1))
-
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                    emt_att%pm_comp(icat,i_pm_comp,1)*con_factor*hour_per_day 
-
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+ &
+
+                !
+                !-- NOx
+                IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "NO" )  THEN
+                
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
+                                                  emt_att%nox_comp(icat,1) * con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
                                                                  delta_emis(nys:nyn,nxl:nxr)
- 
+
+                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "NO2" )  THEN
+
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
+                                                  emt_att%nox_comp(icat,2) * con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                 delta_emis(nys:nyn,nxl:nxr)
+ 
+                !
+                !-- SOx
+                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "SO2" )  THEN
+                  
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
+                                                 emt_att%sox_comp(icat,1) * con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                 delta_emis(nys:nyn,nxl:nxr)
+
+                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "SO4" )  THEN
+                  
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
+                                                 emt_att%sox_comp(icat,2) * con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                 delta_emis(nys:nyn,nxl:nxr)
+ 
+
+                !
+                !-- PMs
+                !-- PM1
+                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1" )  THEN
+
+                   !
+                   !-- Cycle over PM1 components
+                   DO i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,1) )
+
+                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &               !<  kg/m2*s
+                                                     emt_att%pm_comp(icat,i_pm_comp,1) * con_factor * hour_per_day 
+
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                    delta_emis(nys:nyn,nxl:nxr)
                    ENDDO
 
-             !> PM2.5 Compositions
-                ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="PM25") THEN
-
-                !> Cycle over the different pm components for PM2.5 type
-                   DO i_pm_comp= 1,SIZE(emt_att%pm_comp(1,:,2))
-
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                    emt_att%pm_comp(icat,i_pm_comp,2)*con_factor*hour_per_day 
-
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+ &
-                                                                 delta_emis(nys:nyn,nxl:nxr)
+                !
+                !-- PM2.5
+                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM25" )  THEN
+
+                   !
+                   !-- Cycle over PM2.5 components
+                   DO i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,2) )
+
+                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &               !<  kg/m2*s
+                                                     emt_att%pm_comp(icat,i_pm_comp,2) * con_factor * hour_per_day 
+
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                    delta_emis(nys:nyn,nxl:nxr)
  
                    ENDDO
 
-             !> PM10 Compositions
-                ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
-
-                !> Cycle over the different pm components for PM10 type
-                   DO i_pm_comp= 1,SIZE(emt_att%pm_comp(1,:,3))  
-
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)* &
-                                                    emt_att%pm_comp(icat,i_pm_comp,3)*con_factor*hour_per_day 
+                !
+                !-- PM10 
+                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
+
+                   !
+                   !-- Cycle over PM10 components
+                   DO i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,3) )  
+
+                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &               !<  kg/m2*s
+                                                     emt_att%pm_comp(icat,i_pm_comp,3) * con_factor * hour_per_day 
 
                       emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+ &
@@ -1331,17 +1228,18 @@
                    ENDDO
 
-             !> VOCs Compositions: for VOCs, the input value is provided in kg/m**2*s but the composition is provided in mole/kg: a conversion factor for the input that could be eventually provided in, for example, tons/(m**2*s) is still required
-                ELSE IF  (SIZE(match_spec_voc_input) .GT. 0) THEN
-
-                  !TBD: maybe we can avoid the cycle 
-                   DO ivoc= 1,SIZE(match_spec_voc_input)
-
-                      IF (TRIM(spc_names(match_spec_model(ispec)))==TRIM(emt_att%voc_name(ivoc))) THEN    
-
-                         delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*                                    &
-                                                       emt_att%voc_comp(icat,match_spec_voc_input(ivoc))*con_factor*hour_per_day
-
-                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+ &
-                                                                    delta_emis(nys:nyn,nxl:nxr) 
+                !
+                !-- VOCs
+                ELSEIF ( SIZE( match_spec_voc_input ) > 0 )  THEN
+
+                   DO ivoc = 1, SIZE( match_spec_voc_input )
+
+                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == TRIM( emt_att%voc_name(ivoc) ) )  THEN    
+
+                         delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &
+                                                        emt_att%voc_comp(icat,match_spec_voc_input(ivoc)) * &
+                                                         con_factor * hour_per_day
+
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
+                                                                       delta_emis(nys:nyn,nxl:nxr) 
 
                       ENDIF                       
